/*
 * Copyright (C) 2009 - 2010 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

/* $Id$ */

#pragma once

namespace NS_DM_Client
{
	enum NotificationStatus
	{
		e_unknown,
		e_started,
		e_finished,
		e_aborted
	};

	enum EnumFirmwareOperation
	{
		e_FWOError = 0,
		e_FWODownload,
		e_FWOUpdate,
		e_FWODownloadAndUpdate
	};

	extern const char* S_notificationStatusDescription[];

	class INotificationUpdater
	{
	public:
		INotificationUpdater(void* context = 0): m_context(context) {} ;
		virtual ~INotificationUpdater() {};

		virtual void StartDMSessionStatus(bool sessionStarted) = 0;
		virtual void CheckFirmwareUpdateStatus(bool firmwareUpdated) = 0;

		virtual void DMSessionNotif(NotificationStatus status) = 0;
		virtual void FirmwareUpdateNotif(EnumFirmwareOperation fwo, NotificationStatus status) = 0;

		virtual void ProvisioningUpdateNotif(const char* URI) = 0;

		virtual void StartDRMDCollecting(int duration) = 0;
		
	private:
		void* m_context;
	};
}
