/*
 * Copyright (C) 2009 - 2010 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

/* $Id$ */

#pragma once

#include <base/util/MemoryKeyValueStore.h>
#include <syncml/core/Results.h>
#include "serverexchange/wrappers/SResponseCommand.h"


namespace NS_DM_Client
{
	namespace NS_SyncMLCommand
	{
		typedef boost::shared_ptr<class SResultsCommand> SResultsCommandPtr;

		class SResultsCommand : public NS_SyncMLCommand::SResponseCommand
		{
		public:
			SResultsCommand();
			virtual ~SResultsCommand();

			void AddResult(const char *key, const char * value);
			void AddResult(const char *key, const char * value,  const char *format, const char *type);

			Funambol::Results *GetResults();
			/// Get xml representation of the command
			virtual Funambol::StringBuffer * ToString();

		protected:
			virtual void createItemizedCommand();

			inline Funambol::Results *this_results()
			{
				return dynamic_cast<Funambol::Results*>(m_ptrItemizedCommand.get());
			}

		private:
			class StringMap : public Funambol::MemoryKeyValueStore
			{
			public:
				StringMap() {}
				virtual ~StringMap() {}
				virtual int close() { return 0; }
			};

			StringMap m_mapResults;
			StringMap m_mapFormats;
			StringMap m_mapTypes;
		};
	}
}
